#DEFINE WIN32_LEAN_AND_MEAN
#DEFINE LINKFILES
#INCLUDE <windows.h>

NUMLINES	equ 23
DATA SECTION

items STRUCT
	iIndex	dd 0
	szLabel	 db 22 dup (?)
	szDesc   db 42 dup (?)
	  ENDS
sysmetrics  items <SM_CXSCREEN,'SM_CXSCREEN','Screen width in pixels'>
  items <SM_CYSCREEN,              'SM_CYSCREEN' , 			'Screen height in pixels'>
  items <SM_CXVSCROLL,             'SM_CXVSCROLL' , 			'Vertical scroll width'>             
  items <SM_CYHSCROLL, 			  'SM_CYHSCROLL' , 			'Horizontal scroll height'>
  items <SM_CYCAPTION,             'SM_CYCAPTION' , 			'Caption bar height'>
  items <SM_CXBORDER,              'SM_CXBORDER' , 			'Window border width'>
  items <SM_CYBORDER,              'SM_CYBORDER' , 			'Window border height'>
  items <SM_CXFIXEDFRAME,          'SM_CXFIXEDFRAME' , 		'Dialog window frame width'>
  items <SM_CYFIXEDFRAME,          'SM_CYFIXEDFRAME' , 		'Dialog window frame height'>
  items <SM_CYVTHUMB,              'SM_CYVTHUMB' , 			'Vertical scroll thumb height'>
  items <SM_CXHTHUMB,              'SM_CXHTHUMB' , 			'Horizontal scroll thumb width'>
  items <SM_CXICON,                'SM_CXICON' ,				'Icon width'>
  items <SM_CYICON,                'SM_CYICON' , 				'Icon height'>
  items <SM_CXCURSOR,              'SM_CXCURSOR' , 			'Cursor width'>
  items <SM_CYCURSOR,              'SM_CYCURSOR' , 			'Cursor height'>
  items <SM_CYMENU,                'SM_CYMENU' , 				'Menu bar height'>
  items <SM_CXFULLSCREEN,          'SM_CXFULLSCREEN' , 		'Full screen client area width'>
  items <SM_CYFULLSCREEN,          'SM_CYFULLSCREEN' , 		'Full screen client area height'>
  items <SM_CYKANJIWINDOW,         'SM_CYKANJIWINDOW' ,		'Kanji window height'>
  items <SM_MOUSEPRESENT,          'SM_MOUSEPRESENT' , 		'Mouse present flag'>
  items <SM_CYVSCROLL,             'SM_CYVSCROLL' , 			'Vertical scroll arrow height'>
  items <SM_CXHSCROLL,             'SM_CXHSCROLL' , 			'Horizontal scroll arrow width'>
  items <SM_DEBUG,                 'SM_DEBUG' , 				'Debug version flag'>
  items <SM_SWAPBUTTON,            'SM_SWAPBUTTON' , 			'Mouse buttons swapped flag'>
  items <SM_CXMIN,                 'SM_CXMIN' , 				'Minimum window width'>
  items <SM_CYMIN,                 'SM_CYMIN' , 				'Minimum window height'>
  items <SM_CXSIZE,                'SM_CXSIZE' , 				'Min/Max/Close button width'>
  items <SM_CYSIZE,                'SM_CYSIZE' , 				'Min/Max/Close button height'>
  items <SM_CXSIZEFRAME,           'SM_CXSIZEFRAME' , 			'Window sizing frame width'>
  items <SM_CYSIZEFRAME,           'SM_CYSIZEFRAME' , 			'Window sizing frame height'>
  items <SM_CXMINTRACK,            'SM_CXMINTRACK' , 			'Minimum window tracking width'>
  items <SM_CYMINTRACK,            'SM_CYMINTRACK' , 			'Minimum window tracking height'>
  items <SM_CXDOUBLECLK,           'SM_CXDOUBLECLK' , 			'Double click x tolerance'>
  items <SM_CYDOUBLECLK,           'SM_CYDOUBLECLK' , 			'Double click y tolerance'>
  items <SM_CXICONSPACING,         'SM_CXICONSPACING' , 		'Horizontal icon spacing'>
  items <SM_CYICONSPACING,         'SM_CYICONSPACING' , 		'Vertical icon spacing'>
  items <SM_MENUDROPALIGNMENT,     'SM_MENUDROPALIGNMENT' , 	'Left or right menu drop'>
  items <SM_PENWINDOWS,            'SM_PENWINDOWS' , 			'Pen extensions installed'>
  items <SM_DBCSENABLED,           'SM_DBCSENABLED' , 			'Double-Byte Char Set enabled'>
  items <SM_CMOUSEBUTTONS,         'SM_CMOUSEBUTTONS' , 		'Number of mouse buttons'>
  items <SM_SECURE,                'SM_SECURE' , 				'Security present flag'>
  items <SM_CXEDGE,                'SM_CXEDGE' , 				'3-D border width'>
  items <SM_CYEDGE,                'SM_CYEDGE' , 				'3-D border height'>
  items <SM_CXMINSPACING,          'SM_CXMINSPACING' , 		'Minimized window spacing width'>
  items <SM_CYMINSPACING,          'SM_CYMINSPACING' , 		'Minimized window spacing height'>
  items <SM_CXSMICON,              'SM_CXSMICON' , 			'Small icon width'>
  items <SM_CYSMICON,              'SM_CYSMICON' , 			'Small icon height'>
  items <SM_CYSMCAPTION,           'SM_CYSMCAPTION' , 			'Small caption height'>
  items <SM_CXSMSIZE,              'SM_CXSMSIZE' , 			'Small caption button width'>
  items <SM_CYSMSIZE,              'SM_CYSMSIZE' , 			'Small caption button height'>
  items <SM_CXMENUSIZE,            'SM_CXMENUSIZE' , 			'Menu bar button width'>
  items <SM_CYMENUSIZE,            'SM_CYMENUSIZE' , 			'Menu bar button height'>
  items <SM_ARRANGE,               'SM_ARRANGE' , 				'How minimized windows arranged'>
  items <SM_CXMINIMIZED,           'SM_CXMINIMIZED' , 			'Minimized window width'>
  items <SM_CYMINIMIZED,           'SM_CYMINIMIZED' , 			'Minimized window height'>
  items <SM_CXMAXTRACK,            'SM_CXMAXTRACK' , 			'Maximum draggable width'>
  items <SM_CYMAXTRACK,            'SM_CYMAXTRACK' , 			'Maximum draggable height'>
  items <SM_CXMAXIMIZED,           'SM_CXMAXIMIZED' , 			'Width of maximized window'>
  items <SM_CYMAXIMIZED,           'SM_CYMAXIMIZED' , 			'Height of maximized window'>
  items <SM_NETWORK,               'SM_NETWORK' , 				'Network present flag'>
  items <SM_CLEANBOOT,             'SM_CLEANBOOT' , 			'How system was booted'>
  items <SM_CXDRAG,                'SM_CXDRAG' , 				'Avoid drag x tolerance'>
  items <SM_CYDRAG,                'SM_CYDRAG' , 				'Avoid drag y tolerance'>
  items <SM_SHOWSOUNDS,            'SM_SHOWSOUNDS' , 			'Present sounds visually'>
  items <SM_CXMENUCHECK,           'SM_CXMENUCHECK' , 			'Menu check-mark width'>
  items <SM_CYMENUCHECK,           'SM_CYMENUCHECK' , 			'Menu check-mark height'>
  items <SM_SLOWMACHINE,           'SM_SLOWMACHINE' , 			'Slow processor flag'>
  items <SM_MIDEASTENABLED,        'SM_MIDEASTENABLED' , 		'Hebrew and Arabic enabled flag'>
  items <SM_MOUSEWHEELPRESENT,     'SM_MOUSEWHEELPRESENT' , 	'Mouse wheel present flag'>
  items <SM_XVIRTUALSCREEN,        'SM_XVIRTUALSCREEN' , 		'Virtual screen x origin'>
  items <SM_YVIRTUALSCREEN,        'SM_YVIRTUALSCREEN' , 		'Virtual screen y origin'>
  items <SM_CXVIRTUALSCREEN,       'SM_CXVIRTUALSCREEN' , 		'Virtual screen width'>
  items <SM_CYVIRTUALSCREEN,       'SM_CYVIRTUALSCREEN' , 		'Virtual screen height'>
  items <SM_CMONITORS,             'SM_CMONITORS' , 			'Number of monitors'>
  items <SM_SAMEDISPLAYFORMAT,     'SM_SAMEDISPLAYFORMAT' , 	'Same color format flag'> 


ALIGN 4
   	ClassName			DB "MainWinClass",0
	AppName				DB "SYSMETS GOASM VERSION ",0
	szFMT				db "%5d",0
 	hInstance			DD ?
 	Dtest				db 22 dup (?)
	CommandLine			DD ?
;	hwnd				dd ?
	cxChar				dd 0
	      cxCaps		dd 0
	      cyChar		dd 0
	    cyChar_i		dd 0
	   cxCaps_22		dd 0 
	   Caps_Char		dd 0
	

CODE SECTION

Start:

	invoke GetModuleHandle, NULL
	mov [hInstance],eax
	invoke GetCommandLine
	mov [CommandLine],eax
	invoke InitCommonControls
	invoke WinMain,[hInstance],NULL,[CommandLine],SW_SHOWNORMAL
	invoke ExitProcess,eax

WinMain FRAME hInst,hPrevInst,CmdLine,CmdShow
	LOCAL 	 wc:WNDCLASSEX,\
	 	    msg:MSG,\
	 	    hwnd:d

	mov D[wc.cbSize],SIZEOF WNDCLASSEX
	mov D[wc.style], CS_HREDRAW + CS_VREDRAW
	mov [wc.lpfnWndProc], OFFSET WndProc
	mov D[wc.cbClsExtra],NULL
	mov D[wc.cbWndExtra],NULL
	push [hInstance]
	pop [wc.hInstance]
	mov D[wc.hbrBackground],COLOR_WINDOW+1
	mov D[wc.lpszMenuName],NULL
	mov [wc.lpszClassName],OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov [wc.hIcon],eax
	mov [wc.hIconSm],eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov [wc.hCursor],eax
	
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
			WS_OVERLAPPEDWINDOW ,CW_USEDEFAULT,\
			CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
			[hInst],NULL

	mov [hwnd],eax

	invoke ShowWindow, [hwnd],[CmdShow]
	invoke UpdateWindow, [hwnd]

	.messloop
		invoke GetMessage, ADDR msg,0,0,0
		or eax,eax
		JZ >.quit
			invoke TranslateMessage, ADDR msg
			invoke DispatchMessage, ADDR msg
	JMP .messloop
	.quit

	mov eax,[msg.wParam]
	ret
ENDF
;
WndProc FRAME hWnd, uMsg, wParam, lParam
uses esi,edi,ebx,edx
  
local         hdc:d,\ 
;	       cxChar:d,\
;	       cxCaps:d,\		
;	       cyChar:d,\		
;	     cyChar_i:d,\		
;	    cxCaps_22:d,\		 
;	    Caps_Char:d	,\ 
               ps:PAINTSTRUCT,\
    szBuffer [10]:d,\
     		   tm:TEXTMETRIC,\
     	   saveMe:d	   


	mov eax,[uMsg]
	cmp eax,WM_CREATE
	jne >.WMCOMMAND
		invoke	GetDC,[hWnd]
		mov	d[hdc],eax

		;int 3
	    invoke  GetTextMetrics,[hdc],ADDR tm
        mov	ebx,[tm.tmAveCharWidth]					; ebx = cxChar
        mov	[cxChar],ebx 
        mov	al,[tm.tmPitchAndFamily]				;  BYTE  tmPitchAndFamily;
        ;int 3
        and eax,1
        jz >.FALSE_RESULT
        	mov	eax,3
        	jmp > .END_RESULT
        	
.FALSE_RESULT
			mov	eax,3

.END_RESULT 
			shr	ebx,1								; remember cxCaps still in ebx
			xor	edx,edx
			mul	ebx
			mov	[cxCaps],eax
			
			mov	eax,[tm.tmHeight]
			add	eax,[tm.tmExternalLeading]
			mov	[cyChar],eax
				   
			
        invoke  ReleaseDC,[hWnd],[hdc]
		jmp >>.EXIT

	.WMCOMMAND
	cmp eax,WM_COMMAND
	jne >.WMCLOSE
		jmp >>.EXIT

	.WMCLOSE
	cmp eax,WM_CLOSE
	jne >.WMPAINT
		invoke DestroyWindow,[hWnd]
		jmp >>.EXIT
	.WMPAINT	
	cmp	eax,WM_PAINT
		jne	>>.WMDESTROY
		invoke	BeginPaint,[hWnd],ADDR ps
		mov	[hdc],eax
		mov	esi,0

;for (i = 0 ; i < NUMLINES ; i++)		
4_LOOP:	
	;	TextOut (hdc, 0, cyChar * i,                      
    ;                    sysmetrics[i].szLabel,
    ;                    lstrlen (sysmetrics[i].szLabel)) ;
   
		mov	eax,esi				; esi as i counter
		mov	edx,0
		mov	ecx,[cyChar]
		mul	ecx 				;cyChar * i
		mov	[cyChar_i],eax		; save it 
		
		invoke	lstrlen,ADDR sysmetrics.szLabel
		invoke	TextOut,[hdc],0,[cyChar_i],ADDR sysmetrics.szLabel,eax	
	
;--------------------------------------------------------------------		
;		TextOut (hdc, 22 * cxCaps, cyChar * i,      
;                        sysmetrics[i].szDesc,
;                        lstrlen (sysmetrics[i].szDesc)) ;

;               SetTextAlign (hdc, TA_RIGHT | TA_TOP) ;

		mov	eax,[cxCaps]
		mov	edx,0
		mov	ecx,22
		mul ecx						;cxCaps * 22
		mov	[cxCaps_22],eax			; save it for later use	

				
		invoke	lstrlen,ADDR sysmetrics.szDesc      
		invoke	TextOut,[hdc],[cxCaps_22],[cyChar_i],ADDR sysmetrics.szDesc,eax
        invoke	SetTextAlign,[hdc],TA_RIGHT |TA_TOP
;----------------------------------------------------------------------
        
;        TextOut (hdc, 22 * cxCaps + 40 * cxChar, cyChar * i, szBuffer,
;                        wsprintf (szBuffer, TEXT ("%5d"),
;                                  GetSystemMetrics (sysmetrics[i].iIndex))) ;;

;               SetTextAlign (hdc, TA_LEFT | TA_TOP) ;
;
 		
 		mov	eax,[cxChar]
 		mov	ecx,40
 		xor	edx,edx
 		mul	ecx					; 40 * cxChar
 		
 		add	eax,[cxCaps_22] 	; 22 * cxCaps + 40 * cxChar
 		
 		mov	[Caps_Char],eax		;22*cxCaps+40    
 		
 		invoke	GetSystemMetrics,[sysmetrics.iIndex]
		invoke	wsprintf,ADDR szBuffer, ADDR szFMT,eax 		
		invoke	TextOut,[hdc],[Caps_Char],[cyChar_i],ADDR szBuffer,eax			
		
		
		
		inc	esi										; increment COUNTER
		cmp	esi,NUMLINES 
		je	>.END_LOOP
		
		invoke	SetTextAlign,[hdc],TA_LEFT | TA_TOP
		;int3
		jmp << 4_LOOP
.END_LOOP		
        invoke	EndPaint,[hWnd],ADDR ps
		
		jmp	>.EXIT
	.WMDESTROY
	cmp eax,WM_DESTROY
	jne >.DEFPROC
		invoke PostQuitMessage,NULL
		jmp >>.DEFPROC

	.DEFPROC
		invoke DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]		
		ret

	.EXIT

	xor eax,eax
	ret
ENDF

